#!/usr/bin/perl
#
######################################################################
# SQL-Ledger Accounting
# Copyright (C) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#  Contributors:
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#######################################################################
#
# this script is the frontend called from bin/$terminal/$script
# all the accounting modules are linked to this script which in
# turn execute the same script in bin/$terminal/
#
# CHANGE LOG:
#   DS. 2000-07-04  Created
#
#######################################################################


require "sql-ledger.conf";


if ($ENV{CONTENT_LENGTH}) {
  read(STDIN, $_, $ENV{CONTENT_LENGTH});
}

if ($ENV{QUERY_STRING}) {
  $_ = $ENV{QUERY_STRING};
}

if ($ARGV[0]) {
  $_ = $ARGV[0];
}


%form = split /[&=]/;

$form{path} =~ s/%2[fF]/\//g;

# name of this script
$pos = rindex $0, '/';
$script = substr($0, $pos + 1);


if ($form{path}) {

  $form{path} =~ s/\.\.\///g;

  unless ($form{path} =~ /^bin\//) {
    if ($ENV{HTTP_USER_AGENT}) {
      print "Content-type: text/html

      ";
    }

    print "Invalid path!\n";
    die;
  }

  $ARGV[0] = "$_&script=$script";
  require "$form{path}/$script";

} else {

  if ($ENV{HTTP_USER_AGENT}) {
    print qq'Content-type: text/html\n\n';
  }

  print qq'unknown terminal!';

}


# end

