#=====================================================================
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#  Contributors:
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# customer/vendor module
#
# CHANGE LOG:
#   DS. 2000-07-04  Created
#
#======================================================================


use DBI;
use SL::Form;
use SL::CT;

$form = new Form;


if ($form->{action}) {
  require("$userspath/$form->{login}.conf");
  $myconfig{dbpasswd} = unpack 'u', $myconfig{dbpasswd};
  map { $form->{$_} = $myconfig{$_} } qw(stylesheet charset);

  $locale = new Locale $myconfig{countrycode}, "ct";
  &{ $locale->findsub($form->{action}) };
} else {
  $form->error("action= not defined!");
}

# end of main



sub add {

  $form->{title} = "Add";

  $form->{callback} = "$form->{script}?action=add&db=$form->{db}&path=$form->{path}&login=$form->{login}";

  CT->taxaccounts(\%myconfig, \%$form);
  
  &{ "$form->{db}_header" };
  &form_footer;
  
}


sub search {

  $form->{title} = $locale->text("Search for " . ucfirst $form->{db});
 
# class=submit type=submit $locale->text('Search for Customer')
# class=submit type=submit $locale->text('Search for Vendor')
 
  $form->header;
  
  print qq|

<h2>$form->{title}</h2>

<form method=post action=$form->{script}>

<input type=hidden name=db value=$form->{db}>

<table border=1>
<tr valign=top>
<td>
<table>


<tr>
<th align=right>|.$locale->text('Company').qq|</th><td><input name=name size=35></td>
</tr>

<tr>
<th align=right>|.$locale->text('Contact').qq|</th><td><input name=contact size=35></td>
</tr>

<tr>
<th align=right>|.$locale->text('Include in Report').qq|</th>
<td>
<input name="l_name" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Name').qq|
<input name="l_address" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Address').qq|
<input name="l_contact" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Contact').qq|
<input name="l_phone" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Phone').qq|
<input name="l_fax" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Fax').qq|
<input name="l_email" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('E-mail').qq|

</td>
</tr>

</table>
</td>

</tr>
</table>

<p>
<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>

<input class=submit type=submit name=action value="|.$locale->text('Search for ' . ucfirst $form->{db}).qq|">
</form>

<p>|.$locale->text("To display all $form->{db}s, leave fields blank").qq|

</body>
</html>
|;
}


# $locale->text('To display all customers, leave fields blank')
# $locale->text('To display all vendors, leave fields blank')


sub search_for_customer {
  &search_for_name;
}

sub search_for_vendor {
  &search_for_name;
}


sub search_for_name {
  
  CT->search(\%myconfig, \%$form);
  
  $callback = "$form->{script}?action=search_for_name&db=$form->{db}&path=$form->{path}&login=$form->{login}";
  
  $href = "$form->{script}?action=search_for_name&db=$form->{db}&path=$form->{path}&login=$form->{login}&name=" . $form->escape($form->{name}) . "&contact=" . $form->escape($form->{contact});
  
  @columns = $form->sort_columns(qw(name address contact phone fax email));

  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }
  
  if ($form->{name}) {
    $callback .= "&name=$form->{name}";
  }
  if ($form->{contact}) {
    $callback .= "&contact=$form->{contact}";
  }

  $callback = $form->escape($callback . "&sort=$form->{sort}");
  
  $column_header{name} = qq|<th><a href=$href&sort=name><font color=ffffff>|.$locale->text('Name').qq|</a></th>|;
  $column_header{address} = qq~<th><a href=$href&sort="addr1 || addr2 || addr3"><font color=ffffff>~.$locale->text('Address').qq|</a></th>|;
  $column_header{contact} = qq|<th><a href=$href&sort=contact><font color=ffffff>|.$locale->text('Contact').qq|</a></th>|;
  $column_header{phone} = qq|<th><a href=$href&sort=phone><font color=ffffff>|.$locale->text('Phone').qq|</a></th>|;
  $column_header{fax} = qq|<th><a href=$href&sort=fax><font color=ffffff>|.$locale->text('Fax').qq|</a></th>|;
  $column_header{email} = qq|<th><a href=$href&sort=email><font color=ffffff>|.$locale->text('E-mail').qq|</a></th>|;
  

# $locale->text('Customer List')
# $locale->text('Vendor List')

  $form->{title} = $locale->text(ucfirst $form->{db} . " List");

  $form->header;
  
  print qq|
<h2>$form->{title}</h2>

<table border=1>
<tr bgcolor=336666>
|;

  map { print "$column_header{$_}\n" } @column_index;
  
  print qq|
</tr>
|;

  foreach $ref (@{ $form->{CT} }) {

    map { $column_data{$_} = "<td>&nbsp;$ref->{$_}</td>" } qw(address contact phone fax);
    
    $column_data{name} = "<td><a href=$form->{script}?action=edit&id=$ref->{id}&db=$form->{db}&path=$form->{path}&login=$form->{login}&callback=$callback>$ref->{name}</td>";
    
    $column_data{email} = ($ref->{email}) ? "<td><a href=mailto:$ref->{email}>$ref->{email}</a></td>" : "<td>&nbsp;</td>";
    
    print "<tr>";

    map { print "$column_data{$_}\n" } @column_index;

    print qq|</tr>|;
    
  }
  print qq|
</table>

<p>|.$locale->text("Click on $form->{db} name to edit").qq|

|;
 

# $locale->text('Click on customer name to edit')
# $locale->text('Click on vendor name to edit')

}


sub edit {

  CT->get_tuple(\%myconfig, \%$form);

  $form->{title} = "Edit";

  # format discount
  $form->{discount} *= 100;
  
  &{ "$form->{db}_header" };
  &form_footer;

}


sub customer_header {

# class=submit type=submit $locale->text('Add Customer')
# class=submit type=submit $locale->text('Edit Customer')
  
  $tax = qq|<tr><th align=right>|.$locale->text('Taxable').qq|</th><td colspan=3>\n|;

  foreach $item (split / /, $form->{taxaccounts}) {
    if (($form->{tax}{$item}{taxable}) || !($form->{id})) {
      $tax .= qq|<input name="tax_$item" value=1 class=checkbox type=checkbox checked>&nbsp;<b>$form->{tax}{$item}{description}</b>\n|;
    } else {
      $tax .= qq|<input name="tax_$item" value=1 class=checkbox type=checkbox>&nbsp;<b>$form->{tax}{$item}{description}</b>\n|;
    }
  }

  $tax .= qq|</td></tr>|;

  $form->{taxincluded} = ($form->{taxincluded}) ? "checked" : "";
  $form->{creditlimit} = $form->format_amount(\%myconfig, $form->{creditlimit});
  
    
  $form->{title} = $locale->text("$form->{title} Customer");
  
  $form->header;

  print qq|

<h2>$form->{title}</h2>

<form method=post action=$form->{script}>

<table border=1>
<tr>
  <td>

  <table border=0>
  <tr>
    <th colspan=2>|.$locale->text('Billing Address').qq|</th>
    <th>|.$locale->text('Shipping Address').qq|</th>
  </tr>

  <tr>
    <td colspan=2><input name=name size=35 maxsize=35 value="$form->{name}"></td>
    <td><input name=shiptoname size=35 maxsize=35 value="$form->{shiptoname}"></td>
  </tr>

  <tr>
    <td colspan=2><input name=addr1 size=35 maxsize=35 value="$form->{addr1}"></td>
    <td><input name=shiptoaddr1 size=35 maxsize=35 value="$form->{shiptoaddr1}"></td>
  </tr>

  <tr>
    <td colspan=2><input name=addr2 size=35 maxsize=35 value="$form->{addr2}"></td>
    <td><input name=shiptoaddr2 size=35 maxsize=35 value="$form->{shiptoaddr2}"></td>
  </tr>

  <tr>
    <td colspan=2><input name=addr3 size=35 maxsize=35 value="$form->{addr3}"></td>
    <td><input name=shiptoaddr3 size=35 maxsize=35 value="$form->{shiptoaddr3}"></td>
  </tr>

  <tr>
    <td colspan=2><input name=addr4 size=35 maxsize=35 value="$form->{addr4}"></td>
    <td><input name=shiptoaddr4 size=35 maxsize=35 value="$form->{shiptoaddr4}"></td>
  </tr>

  <tr>
    <th align=right>|.$locale->text('Contact').qq|</th>
    <td><input name=contact size=20 maxsize=35 value="$form->{contact}"></td>
    <td>
    <input name=shiptocontact size=20 maxsize=35 value="$form->{shiptocontact}"></td>
  </tr>
  
  <tr>
    <th align=right>|.$locale->text('Phone').qq|</th>
    <td><input name=phone size=20 maxsize=20 value="$form->{phone}"></td>
    <td><input name=shiptophone size=20 maxsize=20 value="$form->{shiptophone}"></td>
  </tr>

  <tr>
    <th align=right>|.$locale->text('Fax').qq|</th>
    <td><input name=fax size=20 maxsize=20 value="$form->{fax}"></td>
    <td><input name=shiptofax size=20 maxsize=20 value="$form->{shiptofax}"></td>
  </tr>

  <tr>
    <th align=right>|.$locale->text('E-mail').qq|</th>
    <td><input name=email size=25 value="$form->{email}"></td>
    <td>
    <input name=shiptoemail size=25 value="$form->{shiptoemail}"></td>
  </tr>
 
  <tr>
    <td colspan=4>
    <b>|.$locale->text('Terms: Net').qq|</b> <input name=terms size=2 value="$form->{terms}"> 
    <b>|.$locale->text('days').qq|</b> \| 
    <b>|.$locale->text('Credit Limit').qq|</b> 
    <input name=creditlimit size=9 value="$form->{creditlimit}"> 
    <b>|.$locale->text('Discount').qq|</b> 
    <input name=discount size=4 value="$form->{discount}"> <b>%</b>
    <b>|.$locale->text('Tax Included').qq|</b>
    <input name=taxincluded class=checkbox type=checkbox value=1 $form->{taxincluded}>
    </td>
  </tr>

  $tax
  
  <tr valign=top>
    <th align=right>|.$locale->text('Notes').qq|</th>
    <td colspan=2 rowspan=3>
    <textarea name=notes rows=3 cols=60>$form->{notes}</textarea>
    </td>
  </tr>
    
  </table>

  </td>
</tr>

|;

}



sub vendor_header {

  $form->{title} = $locale->text("$form->{title} Vendor");
 
  $tax = qq|<tr><th align=right>|.$locale->text('Taxable').qq|</th><td colspan=2>\n|;

  foreach $item (split / /, $form->{taxaccounts}) {
    if (($form->{tax}{$item}{taxable}) || !($form->{id})) {
      $tax .= qq|<input name="tax_$item" value=1 class=checkbox type=checkbox checked>&nbsp;<b>$form->{tax}{$item}{description}</b>\n|;
    } else {
      $tax .= qq|<input name="tax_$item" value=1 class=checkbox type=checkbox>&nbsp;<b>$form->{tax}{$item}{description}</b>\n|;
    }
  }

  $tax .= qq|</td></tr>|;

  $form->{taxincluded} = ($form->{taxincluded}) ? "checked" : "";
 
  $form->header;

# class=submit type=submit $locale->text('Add Vendor')
# class=submit type=submit $locale->text('Edit Vendor')

  print qq|

<h2>$form->{title}</h2>

<form method=post action=$form->{script}>

<table border=1>
<tr>
  <td>

  <table border=0>

  <tr valign=top>
    <td colspan=2>
    <input name=name size=35 maxsize=35 value="$form->{name}">
    </td>
  </tr>

  <tr>
    <td colspan=2>
    <input name=addr1 size=35 maxsize=35 value="$form->{addr1}">
    </td>
  </tr>
  
  <tr>
    <td colspan=2>
    <input name=addr2 size=35 maxsize=35 value="$form->{addr2}">
    </td>
  </tr>
  
  <tr>
    <td colspan=2>
    <input name=addr3 size=35 maxsize=35 value="$form->{addr3}">
    </td>
  </tr>
  
  <tr>
    <td colspan=2>
    <input name=addr4 size=35 maxsize=35 value="$form->{addr4}">
    </td>
  </tr>
  
  <tr>
    <th align=right>|.$locale->text('Contact').qq|</th>
    <td><input name=contact size=20 maxsize=35 value="$form->{contact}"></td>
  </tr>
  
  <tr>
    <th align=right>|.$locale->text('Phone').qq|</th>
    <td><input name=phone size=20 maxsize=20 value="$form->{phone}"></td>
  </tr>

  <tr>
    <th align=right>|.$locale->text('Fax').qq|</th>
    <td><input name=fax size=20 maxsize=20 value="$form->{fax}"></td>
  </tr>

  <tr>
    <th align=right>|.$locale->text('E-mail').qq|</th>
    <td><input name=email size=25 value="$form->{email}"></td>
  </tr>

  <tr>
    <td colspan=2><b>|.$locale->text('Terms: Net').qq|</b>
    <input name=terms size=3 value=$form->{terms}> <b>|.$locale->text('days').qq|</b> \|
    <b>|.$locale->text('Tax Included').qq|</b>
    <input name=taxincluded class=checkbox type=checkbox value=1 $form->{taxincluded}>
    </td>
  </tr>
 
  $tax
  
  <tr valign=top>
    <th align=right>|.$locale->text('Notes').qq|</th>
    <td colspan=2 rowspan=3>
    <textarea name=notes rows=3 cols=60>$form->{notes}</textarea>
    </td>
  </tr>
  
  </table>

  </td>
</tr>

|;

}


sub form_footer {

  print qq|

<input name=id type=hidden value=$form->{id}>
<input name=taxaccounts type=hidden value="$form->{taxaccounts}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>

<input type=hidden name=callback value="$form->{callback}">
<input type=hidden name=db value=$form->{db}>

</table>

<input class=submit type=submit name=action value="|.$locale->text('Save ' . ucfirst $form->{db}).qq|">

|;

  if ($form->{id}) {
    print qq|<input class=submit type=submit name=action value="|.$locale->text('Delete ' . ucfirst $form->{db}).qq|">|;
  }

  print "</form>";

# class=submit type=submit $locale->text('Save Customer')
# class=submit type=submit $locale->text('Delete Customer')
# class=submit type=submit $locale->text('Save Vendor')
# class=submit type=submit $locale->text('Delete Vendor')

}


sub delete_customer {

  $rc = CT->delete_customer(\%myconfig, \%$form);
  
  if ($rc == -1) {
    $form->error($locale->text('Transactions exist, cannot delete customer!'));
  }

  $form->isdeleted($rc);

}


sub save_customer {

  $form->isblank("name", $locale->text("Customer Name missing!"));
  CT->save_customer(\%myconfig, \%$form);
  $form->redirect;
  
}


sub save_vendor {

  $form->isblank("name", $locale->text("Vendor Name missing!"));
  CT->save_vendor(\%myconfig, \%$form);
  $form->redirect;
  
}



sub delete_vendor {

  $rc = CT->delete_vendor(\%myconfig, \%$form);
  
  if ($rc == -1) {
    $form->error($locale->text('Transactions exist, cannot delete vendor!'));
  }

  $form->isdeleted($rc);

}


