#!/usr/bin/perl

sub transfer_file {
  my $FH = shift;
  my $filename = shift;

  my $exec_bit = (-x $filename);

  if ($exec_bit) {
    print "Executing CGI\n";
    exec_get_cgi($FH, $filename);
  }
  else {
    # Transfer file
    open (FILE, $filename) or my $error = $!;
    if ($error) {
      if ($error eq "No such file or directory") {
	print LOGGER "INSERT\t$http_request{Method}\t$http_request{Object}\t$http_parameters{Host}\t404\t$peeraddress\t\n";
	&show_error_page(404, $FH);
      }
      elsif ($error eq "Permission denied") {
	print LOGGER "INSERT\t$http_request{Method}\t$http_request{Object}\t$http_parameters{Host}\t404\t$peeraddress\t\n";
	&show_error_page(403, $FH);
      }
      else {
	print LOGGER "INSERT\t$http_request{Method}\t$http_request{Object}\t$http_parameters{Host}\t500\t$peeraddress\tFile access error: $error\n";
	&show_error_page(500, $FH, "File access error: open() returned \"$error\"");
	print $error."\n";
      }
    }

    my @bits = split(/\./, $filename);
    my $extension = pop @bits;
    my $mimetype;
    if ($mime{$extension}) {
      $mimetype = $mime{$extension};
    }
    else {
      $mimetype = "application/octet-stream";
    }

    print $FH "$http_request{Version} 200 OK\r\n";
    print $FH "Server: $config{Version}\r\n";
    print $FH "Content-length: ".(-s $filename)."\r\n";
    print $FH "Content-type: $mimetype\r\n";
    print $FH "\r\n";
    print $FH <FILE> if ($http_request{Method} eq "GET");
    print "File transferred\n";
    close $FH;
    close FILE;
    print LOGGER "INSERT\t$http_request{Method}\t$http_request{Object}\t$http_parameters{Host}\t200\t$peeraddress\t\n";
    exit;
  }
}

sub transfer_icon {
  my $FH = shift;

  my @bits = split(/\./, $http_request{Object});
  my $extension = pop @bits;
  my $mimetype;
  if ($mime{$extension}) {
    $mimetype = $mime{$extension};
  }
  else {
    $mimetype = "application/octet-stream";
  }

  print $FH "$http_request{Version} 200 OK\r\n";
  print $FH "Server: $config{Version}\r\n";
  print $FH "Content-type: $mimetype\r\n";
  print $FH "\r\n";
  print $FH $iconcache{$http_request{Object}};
  print "Icon transferred\n";
  close $FH;

  exit;
}

sub exec_get_cgi {
  my $FH = shift;
  my $filename = shift;

  # server_addr
  # document_root
  &setenv;
  
  my @dirs = split(/\//, $filename);
  my $file = pop @dirs;
  my $path = join("/", @dirs);
  if (!chdir($path)) {
    &show_error_page(500, $FH, "Could not change directory to $path");
  }
	      
  if (!open(CGI, "\"$filename\"|")) {
    my $error = $!;
    print "Error: $error\n";
    &show_error_page(500, $FH, "File access error: open() returned \"$error\"");
  }
  print $FH "$http_request{Version} 200 OK\r\n";
  print $FH "Server: $config{Version}\r\n";
  print $FH <CGI>;
  close CGI;
  close $FH;
  exit;
}

sub exec_post_cgi {
  my $FH = shift;
  my $filename = shift;

  &setenv($FH);
  $ENV{CONTENT_LENGTH} = $http_parameters{'Content-length'};
  $ENV{CONTENT_TYPE} = $http_parameters{'Content-type'};

  my @dirs = split(/\//, $filename);
  my $file = pop @dirs;
  my $path = join("/", @dirs);
  if (!chdir($path)) {
    &show_error_page(500, $FH, "Could not change directory to $path");
  }

  if(!open2(CGIREAD, CGIWRITE, "\"$filename\"")) {
    my $error = $!;
    print "Error $error\n";
    &show_error_page(500, $FH, "File access error: open2() returned \"$error\"");
  }
  print CGIWRITE $http_request{Body};
  close CGIWRITE;

  print $FH "$http_request{Version} 200 OK\r\n";
  print $FH "Server: $config{Version}\r\n";
  print $FH <CGIREAD>;
  close CGIREAD;
  close $FH;
  exit;
}

sub setenv {
  my $FH = shift;

  %ENV = undef;

  %ENV = (GATEWAY_INTERFACE    => "CGI/1.1",
	  PATH_INFO            => "/",
	  QUERY_STRING         => $http_request{Query},
	  REMOTE_ADDR          => $peeraddress,
	  REQUEST_METHOD       => $http_request{Method},
	  SCRIPT_NAME          => $http_request{Path},
	  SERVER_PORT          => $config{'HTTP Port'},
	  SERVER_PROTOCOL      => $http_request{Version},
	  SERVER_SOFTWARE      => $config{Version}
	 );

  if ($http_parameters{Host}) {
    $ENV{SERVER_NAME} = $http_parameters{Host};
    if ($vhosts{$http_parameters{Host}}) {
      $ENV{DOCUMENT_ROOT} = $vhosts{$http_parameters{Host}};
    }
    else {
      $ENV{DOCUMENT_ROOT} = $config{'Document Root'};
    }
  }
  else {
    $ENV{SERVER_NAME} = $config{'HTTP Host'};
    $ENV{DOCUMENT_ROOT} = $config{'Document Root'};
  }

  $ENV{REMOTE_HOST} = gethostbyaddr($iaddr, AF_INET);

  foreach $param (keys %http_parameters) {
    my $envparam;
    $envparam = uc($param);
    $envparam =~ s/-/_/g;
    $envparam = "HTTP_" . $envparam;
    $ENV{$envparam} = $http_parameters{$param};
  }

}

return 1;
