#!/usr/bin/perl

use Cwd;

sub get_head_handler {
  my $FH = shift;

  my $filename;
  my $absolute_path;
  
  unless ($config{'Document Root'} =~ /^\//) {
    $absolute_path = cwd . "/";
  }
  
  if ($http_request{Path} =~ /^\/icons/) {
    print "Serving cached icon $http_request{Path}\n";
    &transfer_icon($FH)
  }
  elsif (($http_parameters{Host}) && ($vhosts{$http_parameters{Host}})) {
    $filename = $vhosts{$http_parameters{Host}} . $http_request{Path};
  }
  else {
    $filename = $absolute_path . $config{'Document Root'} . $http_request{Path};
  }

  print "Serving file at $filename\n";

  if (-d $filename) {
    if ($http_request{Path} =~ /\/$/) {
      &list_directory($FH, $filename);
    }
    else {
      &redirect($FH, 302, $http_request{Path}."/");
    }
  }
  else {
    &transfer_file($FH, $filename);
  }

  &show_error_page(500, $FH, "Error handling GET or HEAD request");
}

sub post_handler {
  my $FH = shift;

  my $filename;
  my $absolute_path;

  unless ($config{'Document Root'} =~ /^\//) {
    $absolute_path = cwd . "/";
  }
 
  if (($http_parameters{Host}) && ($vhosts{$http_parameters{Host}})) {
    $filename = $vhosts{$http_parameters{Host}} . $http_request{Path};
  }
  else {
    $filename = $absolute_path . $config{'Document Root'} . $http_request{Object};
  }

  while(($filename) =~ /^(.*)\%(..)(.*)$/) { $filename = $1 . chr(hex($2)) . $3; }
  print "Executing CGI at $filename\n";

  &show_error_page(404, $FH) unless (-e $filename);
  &show_error_page(403, $FH, "Not a valid CGI program") unless (-x $filename);

  &exec_post_cgi($FH, $filename);
}

return 1;
