CREATE SEQUENCE id
  start 10000 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
--
SELECT nextval ('id');
--
CREATE TABLE makemodel (
  id int DEFAULT nextval ( 'id' ),
  parts_id int,
  name text
);
--
CREATE TABLE gl (
  id int DEFAULT nextval ( 'id' ),
  source text,
  description text,
  transdate date DEFAULT 'current_date'
);
--
CREATE TABLE chart (
  id int DEFAULT nextval ( 'id' ),
  accno int UNIQUE,
  description text,
  charttype char(1) DEFAULT 'A',
  gifi int,
  category char(1),
  link text
);
--
CREATE TABLE defaults (
  inventory_accno_id int,
  income_accno_id int,
  expense_accno_id int,
  invnumber text,
  ponumber text,
  yearend varchar(5),
  nativecurr varchar(3),
  weightunit varchar(5),
  businessnumber text,
  version varchar(8)
);
INSERT INTO defaults (version) VALUES ('1.6.0');
--
CREATE TABLE acc_trans (
  trans_id int,
  chart_id int,
  amount float,
  transdate date DEFAULT 'current_date'
);
--
CREATE TABLE invoice (
  id int DEFAULT nextval ( 'id' ),
  trans_id int,
  inventory_accno_id int,
  income_accno_id int,
  expense_accno_id int,
  parts_id int,
  partnumber text,
  description text,
  qty float4,
  allocated float4,
  sellprice float,
  discount float4,
  unit varchar(5),
  assemblyitem bool
);
--
CREATE TABLE vendor (
  id int DEFAULT nextval ( 'id' ),
  name varchar(35),
  addr1 varchar(35),
  addr2 varchar(35),
  addr3 varchar(35),
  addr4 varchar(35),
  contact varchar(35),
  phone varchar(20),
  fax varchar(20),
  email text,
  notes text,
  terms int2 DEFAULT 0,
  taxincluded bool
);
--
CREATE TABLE customer (
  id int DEFAULT nextval ( 'id' ),
  name varchar(35),
  addr1 varchar(35),
  addr2 varchar(35),
  addr3 varchar(35),
  addr4 varchar(35),
  contact varchar(35),
  phone varchar(20),
  fax varchar(20),
  email text,
  notes text,
  discount float4,
  taxincluded bool,
  creditlimit float,
  terms int2 DEFAULT 0,
  shiptoname varchar(35),
  shiptoaddr1 varchar(35),
  shiptoaddr2 varchar(35),
  shiptoaddr3 varchar(35),
  shiptoaddr4 varchar(35),
  shiptocontact varchar(20),
  shiptophone varchar(20),
  shiptofax varchar(20),
  shiptoemail text
);
--
CREATE TABLE parts (
  id int DEFAULT nextval ( 'id' ),
  partnumber text,
  description text,
  unit varchar(5),
  listprice float,
  sellprice float,
  lastcost float,
  priceupdate date DEFAULT 'current_date',
  weight float4,
  onhand float4,
  notes text,
  makemodel bool DEFAULT FALSE,
  assembly bool DEFAULT FALSE,
  alternate bool DEFAULT FALSE,
  rop float4,
  inventory_accno_id int,
  income_accno_id int,
  expense_accno_id int
);
--
CREATE TABLE assembly (
  id int,
  parts_id int,
  qty float
);
--
CREATE TABLE ar (
  id int DEFAULT nextval ( 'id' ),
  invnumber text,
  transdate date DEFAULT 'current_date',
  customer int,
  taxincluded bool,
  amount float,
  netamount float,
  paid float,
  datepaid date,
  duedate date,
  invoice bool DEFAULT FALSE,
  shippingpoint text,
  terms int2 DEFAULT 0,
  notes text
);
--
CREATE TABLE ap (
  id int DEFAULT nextval ( 'id' ),
  invnumber text,
  transdate date DEFAULT 'current_date',
  vendor int,
  taxincluded bool,
  amount float,
  netamount float,
  paid float,
  datepaid date,
  duedate date,
  invoice bool DEFAULT FALSE,
  ordnumber text
);
--
CREATE TABLE partstax (
  parts_id int,
  chart_id int
);
--
CREATE TABLE tax (
  chart_id int,
  rate float,
  taxnumber text
);
--
CREATE TABLE customertax (
  customer_id int,
  chart_id int
);
--
CREATE TABLE vendortax (
  vendor_id int,
  chart_id int
);
